d191161f3b11f851066410341423583fad0d0aaf
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/sh
2 # Filename:      grml-bootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Sam Okt 06 18:01:53 CEST 2007 [mika]
8 ################################################################################
9 # http://www.debian.org/releases/stable/i386/index.html.en
10
11 set -e # exit on any error
12
13 VERSION='0.11'
14
15 # source core functions {{{
16 . /etc/grml/lsb-functions
17 . /etc/grml/script-functions
18 # }}}
19
20 # make sure we have what we need {{{
21 check4progs debootstrap || exit 1
22 check4root || exit 1
23 # }}}
24
25 # without config file it won't work {{{
26 if [ -r /etc/debootstrap/config ] ; then
27    . /etc/debootstrap/config
28 else
29    eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
30    exit 1
31 fi
32 # }}}
33
34 # cmdline handling {{{
35 usage() {
36   einfo "$0 - version $VERSION"
37   echo  "   A wrapper around debootstrap for installing plain Debian via grml"
38   echo
39   einfo "Usage: $0 [options]"
40   echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
41   echo
42   einfo "Valid options:"
43   echo  "
44     -h|--help                   Print this usage information and exit.
45     -v|--version                Show summary of options and exit.
46
47     -t|--target <target>        Target partition (/dev/...) or directory.
48     -r|--release <release>      Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
49     -m|--mirror <URL>           Specify mirror which should be used for apt-get/aptitude.
50     -i|--iso <mnt>              Specify mountpoint where Debian ISO is mounted to (instead of using mirror)
51     -p|--mntpoint <mnt>         Specify mountpoint that should be used for mounting the target system.
52     --groot <device>            Specify root device for usage in grub (corresponds with \$TARGET).
53     --grub <device>             Where do you want to install grub to? Use grub syntax for specifying.
54     --password <pwd>            Use specified password as password for user root. Use with caution.
55     --boot_append <appendline>  Add specified appendline to kernel whilst booting
56
57 "
58 }
59
60 while [ "$#" -gt "0" ] ; do
61     case $1 in
62         -v|--version)
63             einfo "$0 - version $VERSION"
64             einfo "Send bug reports to Michael Prokop <mika@grml.org>."
65             eend 0
66             exit 0
67             ;;
68         -t|--target)
69             shift
70             TARGET=$1
71             ;;
72         --grub)
73             shift
74             GRUB=$1
75             ;;
76         --groot)
77             shift
78             GROOT=$1
79             ;;
80         --release)
81             shift
82             RELEASE=$1
83             ;;
84         -p|--mntpoint)
85             shift
86             MNTPOINT=$1
87             ;;
88         --password)
89             shift
90             ROOTPASSWORD=$1
91             ;;
92         -m|--mirror)
93             shift
94             MIRROR=$1
95             CHROOTMIRROR=$1
96             ;;
97         -i|--iso)
98             shift
99             [ -n "$MIRROR" ] && unset MIRROR
100             ISO=$1
101             ;;
102         -h|--help)
103             usage ; eend 0
104             eend 0
105             exit 0
106             ;;
107         *)
108             eerror "Syntax error."
109             usage ; eend 1
110             exit 1
111             ;;
112     esac
113     shift
114 done
115 # }}}
116
117 # set/check variables {{{
118
119 # inside the chroot system the locales might not be available, so use minimum:
120 export LANG=C
121 export LC_ALL=C
122
123 if [ -z "$STAGES" ] ; then
124    STAGES='/etc/debootstrap/stages'
125    [ -d "$STAGES" ] || mkdir -p "$STAGES"
126 fi
127
128 if [ -r "$STAGES"/grml-debootstrap ] ; then
129    if grep -q done $STAGES/grml-debootstrap ; then
130       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
131       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
132    fi
133 fi
134
135 PARTITION=''
136 DIRECTORY=''
137
138 case $TARGET in
139   /dev/*)
140     PARTITION=1
141     ;;
142   *)
143     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
144     DIRECTORY=1
145     MNTPOINT="$TARGET"
146     MKFS=''
147     TUNE2FS=''
148     FSCK=''
149     GRUB=''
150     GROOT=''
151     ;;
152 esac
153
154 if [ -n "$ARCH" ] ; then
155    ARCHCMD="--arch $ARCH"
156    ARCHINFO=" (${ARCH})"
157 else
158    ARCH="$(dpkg --print-architecture)"
159    ARCHCMD="--arch $ARCH"
160    ARCHINFO=" (${ARCH})"
161 fi
162
163 # make sure we have the right syntax when using an iso image
164 case $ISO in
165    file*) # do nothing
166     ;;
167    *)
168     ISO=file:$1
169     ;;
170 esac
171 ISODIR=${ISO##file:}
172 ISODIR=${ISODIR%%/}
173
174 # provide variables to chroot system
175 touch /etc/debootstrap/variables
176 chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
177 [ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
178 [ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
179 [ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
180 [ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
181 [ -n "$ISO" ]    && echo "ISO=$ISO"       >> /etc/debootstrap/variables
182 [ -n "$ISODIR" ] && echo "ISODIR=$ISO"    >> /etc/debootstrap/variables
183 [ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
184 [ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> /etc/debootstrap/variables
185 [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
186
187 # make sure at least $TARGET is set [the partition for the new system]
188 if [ -z "$TARGET" ] ; then
189    eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
190    exit 1
191 fi
192 # }}}
193
194 # helper functions {{{
195 # we want to exit smoothly and clean:
196 bailout(){
197   # make sure $TARGET is not mounted when exiting grml-debootstrap
198   if [ -n "$MNTPOINT" ] ; then
199      if grep -q $MNTPOINT /proc/mounts ; then
200         # make sure nothing is left inside chroot so we can unmount it
201         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
202         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
203         # ugly, but make sure we really don't leav anything
204         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
205         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
206         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
207         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
208         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" 1>/dev/null 2>&1
209         einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
210      fi
211   fi
212   [ -n "$1" ] && EXIT="$1" || EXIT="1"
213   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
214   exit "$EXIT"
215 }
216 trap bailout 1 2 3 15
217
218 # we want to execute all the functions only once, simple check for it:
219 stage() {
220   if [ -n "$2" ] ; then
221      echo "$2" > "$STAGES/$1"
222      return 0
223   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
224      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
225      eindent
226        ewarn "To reexecute it clean up the according directory inside $STAGES" ; eend 0
227      eoutdent
228      return 1
229   fi
230 }
231 # }}}
232
233 # user should recheck his configuration {{{
234 # support full automatic installation:
235 checkforrun() {
236    dialog --timeout 10 --title "$0" \
237           --yesno "Do you want to stop at this stage?
238
239 Notice: you are running grml-debootstrap in non-interactive mode.
240 grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
241 Last chance to quit. Timeout of 10 seconds running....
242
243 Do you want to stop now?" 0 0 2>/dev/null
244 }
245
246 if [ -n "$AUTOINSTALL" ] ; then
247    if checkforrun ; then
248       eerror "Exiting as requested" ; eend 0
249       exit 1
250    fi
251 else # if not running automatic installation display configuration and prompt for execution:
252    einfo "$0 - Please recheck configuration before execution:"
253    echo
254    echo "   Target:           $TARGET"
255       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
256       [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
257       [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
258       [ -n "$ISO" ] && echo "   Using iso:        $ISO"
259       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
260       echo
261    einfon "Is this ok for you? [y/N] "
262    read a
263    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
264       eerror "Exiting as requested." ; eend 1
265       exit 1
266    fi
267 fi
268 # }}}
269
270 # create filesystem {{{
271 mkfs() {
272   if [ -n "$MKFS" ] ; then
273      einfo "Running $MKFS on $TARGET"
274      $MKFS $TARGET
275      eend $?
276   fi
277 }
278 # }}}
279
280 # modify filesystem settings {{{
281 tunefs() {
282   if [ -n "$TUNE2FS" ] ; then
283      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
284      $TUNE2FS $TARGET
285      eend $?
286   fi
287 }
288 # }}}
289
290 # mount the new partition or if it's a directory do nothing at all {{{
291 mount_target() {
292   if [ -n "$DIRECTORY" ] ; then
293      einfo "Running grml-debootstrap on a directory, nothing to mount."
294   else
295      if grep -q $TARGET /proc/mounts ; then
296         eerror "$TARGET already mounted, exiting."
297      else
298        [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
299        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
300        einfo "Mounting $TARGET to $MNTPOINT"
301        mount -o rw,suid,dev $TARGET $MNTPOINT
302        eend $?
303      fi
304   fi
305   if [ -n "$ISODIR" ] ; then
306      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
307      mkdir -p "$MNTPOINT/$ISODIR"
308      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
309      eend $?
310   fi
311 }
312 # }}}
313
314 # install main chroot {{{
315 debootstrap_system() {
316   if ! grep -q $MNTPOINT /proc/mounts ; then
317           mount_target
318   fi
319   if grep -q $MNTPOINT /proc/mounts ; then
320      einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
321      [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
322      $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
323      eend $?
324   else
325      eerror "Error: $MNTPOINT not mounted, can not continue."
326      eend 1
327   fi
328 }
329 # }}}
330
331 # prepare chroot via chroot-script {{{
332 preparechroot() {
333   einfo "Preparing chroot system"
334   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
335   chmod 755 $MNTPOINT/bin/chroot-script
336   mkdir $MNTPOINT/etc/debootstrap/
337
338   # make sure we have our files for later use via chroot-script
339   cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
340   cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
341   cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
342
343   cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
344
345   # make sure we can access network [relevant for cdebootstrap]
346   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
347
348   # setup default locales
349   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
350
351   # copy any existing existing files to chroot
352   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
353   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
354   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
355   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
356   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
357   eend 0
358 }
359 # }}}
360
361 # execute chroot-script {{{
362 chrootscript() {
363   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
364      mount_target
365   fi
366   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
367      einfo "Executing chroot-script now"
368      chroot "$MNTPOINT" /bin/chroot-script
369      eend $?
370   else
371      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
372      eend 1
373   fi
374 }
375 # }}}
376
377 # install booloader grub {{{
378 grub_install() {
379   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
380      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
381   else
382      einfo "Installing grub on ${GRUB}:"
383      [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
384      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
385      eend $?
386   fi
387 }
388 # }}}
389
390 # unmount $MNTPOINRT {{{
391 umount_chroot() {
392   if [ -n "$ISODIR" ] ; then
393      if grep -q "$ISODIR" /proc/mounts ; then
394         einfo "Unmount $MNTPOINT/$ISODIR"
395         umount "$MNTPOINT/$ISODIR"
396         eend $?
397      fi
398   fi
399   if grep -q "$MNTPOINT" /proc/mounts ; then
400      if [ -n "$PARTITION" ] ; then
401         einfo "Unmount $MNTPOINT"
402         umount $MNTPOINT
403         eend $?
404      fi
405   fi
406 }
407 # }}}
408
409 # execute filesystem check {{{
410 fscktool() {
411   if [ "$FSCK" = 'yes' ] ; then
412      [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
413      einfo "Checking filesystem on $TARGET using $FSCKTOOL"
414      $FSCKTOOL $TARGET
415      eend $?
416   fi
417 }
418 # }}}
419
420 # now execute all the functions {{{
421 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
422          chrootscript grub_install umount_chroot fscktool ; do
423     if stage $i ; then
424        $i && stage $i done || bailout 2 "i"
425     fi
426 done
427 # }}}
428
429 # stages {{{
430   echo done > $STAGES/grml-debootstrap
431 # }}}
432
433 if [ -n "$AUTOINSTALL" ] ; then
434    dialog --title "$0" --msgbox \
435           "Finished execution of ${0}.
436 Enjoy your Debian system." 6 60
437 else
438    einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
439 fi
440
441 ## END OF FILE #################################################################
442 # vim: ai tw=100 expandtab foldmethod=marker